import astropy,os,scipy
import numpy as np
from astropy.io import fits

os.system('ls e*.fits > fits.lst')

filename=open('fits.lst','r')
date=next(filename)[1:5]
filename.close()

num_flat=[0,0,0,0,0]
name_filter=['g','bokr','r','z','u']

for line in open("fits.lst"):
    line=line.strip("\n")
    if (fits.getval(line,'IMAGETYP',0) == 'flat'):
        filter=fits.getval(line,'FILTER',0)
        for i in range(5):
            if (filter == name_filter[i]):
                num_flat[i]+=1

#print num_flat
#raw_input()

for i in range(5):
    if (num_flat[i] != 0):

        flat_median=np.empty((500,16))
        flat_mean=np.empty((16))
        flat_name='flat_'+date+'_'+name_filter[i]+'.fits'
        print(flat_name)

        for k in range(16):
            print('CCD  ',k+1)
            list=[]
            flat1_all=np.empty((2048,2036))
            j=0
            for line in open("fits.lst"):
                line=line.strip("\n")
                object=fits.getval(line,'IMAGETYP',0)
                filter=fits.getval(line,'FILTER',0)
                if (object == 'flat') and (filter == name_filter[i]):
                    flat=fits.open(line)
                
                    if (j == 0) and  (k == 0):
                        flat1=flat

                    data=flat[k+1].data[:2048,:2036]

                    flat_median[j,k]=np.median(data[500:1500,500:1500])
                    data/=flat_median[j,k]
                    list.append(data)
                    j=j+1

            flat_all=np.array(list)

            flat_all.sort(0)#np.median(bias[0:])
    
            flat1_all=0.5*(flat_all[(j-1)/2,:,:]+flat_all[j/2,:,:])

            flat1[k+1].data[:2048,:2036]=flat1_all[:2048,:2036]

        for k in range(16):
            data=flat[k+1].data[:2048,:2036]
            flat[k+1].data[:2048,:2036]=flat1[k+1].data[:2048,:2036]#*flat_mean[k]/np.mean(flat_mean)

        flat.writeto(flat_name,clobber='Ture')

        flat.close()


